import QtQuick
import QtQuick.Controls
import QtQuick.Layouts

import "../../../components"
import "../"

import Artix.Core
import Artix.Gui

/**
 * @brief Панель оплаты
 */
ColumnLayout {
    id: root
    spacing: 16

    signal back()
    signal stornoAll()
    signal commit(var action, var args)
    property var action
    readonly property TextField inputField: inputField

    // Поле ввода
    BasicTextField {
        id: inputField

        Layout.fillWidth: true
        Layout.preferredHeight: 64
        Style.class: "documentSubtotalInput"
        padding: 12
        verticalAlignment: Text.AlignVCenter
        horizontalAlignment: Text.AlignRight
        hideCursor: true
        fixedCursorPosition: true
        validator: DoubleValidator {
            notation: DoubleValidator.StandardNotation
            bottom: 0.0
            decimals: 2
        }
    }
    Item {
        Layout.preferredHeight: 136
    }
    // Клавиатура и панель действий
    GridLayout {
        rowSpacing: 8
        columnSpacing: 8
        columns: 2
        rows: 3

        BasicButton {
            Style.class: "actionPanelDelegate24px600"
            Layout.preferredWidth: 256
            Layout.preferredHeight: 70
            Layout.row: 0
            Layout.column: 1

            textLayout {
                fillWidth: true
                fillHeight: true
            }
            iconLayout {
                alignment: Qt.AlignRight | Qt.AlignTop
                preferredWidth: 32
                preferredHeight: 32
            }
            verticalAlignment: Text.AlignBottom
            Tr { code: "actionPanelButtonStorno"; defaultMessage: "Отмена чека" }
            onClicked: root.stornoAll()
        }
        BasicButton {
            Style.class: "actionPanelDelegate24px600"
            Layout.preferredWidth: 256
            Layout.preferredHeight: 70
            Layout.row: 1
            Layout.column: 1

            textLayout {
                fillWidth: true
                fillHeight: true
            }
            iconLayout {
                alignment: Qt.AlignRight | Qt.AlignTop
                preferredWidth: 32
                preferredHeight: 32
            }
            verticalAlignment: Text.AlignBottom
            Tr { code: "actionPanelButtonBack"; defaultMessage: "Назад" }
            onClicked: root.back()
        }
        BasicButton {
            Style.class: "actionPanelDelegateContinue"
            Layout.preferredWidth: 256
            Layout.preferredHeight: 147
            Layout.row: 2
            Layout.column: 1
            Layout.columnSpan: 2

            textLayout {
                fillWidth: true
                fillHeight: true
            }
            iconLayout {
                alignment: Qt.AlignRight | Qt.AlignTop
                preferredWidth: 32
                preferredHeight: 32
            }
            verticalAlignment: Text.AlignBottom
            icon: Style.parameter("icon.actionPanel.arrow")
            Tr { code: "actionPanelButtonAdd"; defaultMessage: "Добавить" }
            onClicked: {
                let args = {}
                if (inputField.text.length > 0)
                    args["amount"] = inputField.text
                root.commit(root.action, args)
            }
        }
        InlineKeyboard {
            Style.class: "actionPanelDelegate"
            Layout.fillHeight: true
            Layout.preferredWidth: 256
            Layout.row: 0
            Layout.rowSpan: 3
            Layout.column: 0
            layoutType: "digits"
        }
    }
}
